<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="/css/bootstrap.css">
    <script src="/js/jquery.min.js"></script>
    <script src="/js/bootstrap.min.js"></script>
    <script src="/js/web3.min.js"></script>

    <script>
        $(document).ready(function () {
            console.log("Document ist ready");
            getCurrentMarket();
            registerMarketEvents();
        });

        function getCurrentMarket() {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/blockchain/auctionhouse/queue",
                timeout: 100000,
                success: function (data) {
                    console.log("REST Call");
                    console.log(data);
                    loadMarketData(data);

                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("getCurrentMarket: error");
                    console.log(parsedjson);
                    console.log(errorThrown);
                }
            });
        }
        function registerMarketEvents() {
            //Has to be client side to watch for changes
            if (typeof web3 !== 'undefined') {
                web3 = new Web3(web3.currentProvider);
            } else {
                web3 = new Web3(new Web3.providers.HttpProvider("http://localhost:8545"));
                console.log("localhost");
            }

            web3.eth.defaultAccount = web3.eth.coinbase;

            var auctionhouseAbi = <%- JSON.stringify(abi) %>;
            var contractAddress = <%- contractAddress %>;
            console.log("Contract-Address"+contractAddress);
            var AuctionHouse = web3.eth.contract(auctionhouseAbi).at(contractAddress);
            console.log("Current Tail"+ AuctionHouse.tail());
            AuctionHouse.TokenReserved(updateEntry);
            AuctionHouse.TokenSold(removeEntry);
            AuctionHouse.TokenOffered(addEntry);
        }
        function updateEntry(error, result) {
            var id = "#" + result.args.addressToken;
            var update = `
                <td class="reservator">
                    ${result.args.reservatorName}
                </td>`;

            console.log("id " + id);
            console.log("Reservator " + $(id).find('.reservator').html(update));
            console.log(result);
        }
        function removeEntry(error, result) {
            var id = "#" + result.args.addressToken;
            function deleteElement() {
                $(id).remove();
            }
            $(id).fadeOut(1000, deleteElement);
            console.log("Remove");
        }
        function addEntry(error, result) {
            var id = "#" + result.args.addressToken;
            var htmlElement = generateHTML(result.args.addressToken, result.args.creatorName, '');
            var newRow = $(htmlElement);
            newRow.hide();
            $('#overview tbody').prepend(newRow);
            newRow.fadeIn(1000);
            console.log("New " + result.args);
        }

        function generateHTML(id, creator, reservator) {
            var newRow = `
                <tr id="${id}">
                    <td class="creator">
                        ${creator}
                    </td>
                    <td class="reservator">
                        ${reservator}
                    </td>
                </tr>
                `;
            return newRow;
        }

        function loadMarketData(data) {
            for (var i in data) {
                if (data != undefined) {
                    var htmlElement = generateHTML(data[i].address, data[i].creatorName, data[i].reservatorName);
                    $('#overview tbody').prepend(htmlElement);
                } else {
                }
            }
        }

    </script>

</head>

<body>
    <% include ../partials/header %>
        <!--main -->
        <div class="container">

            <table class="table table-striped" id="overview">
                <thead>
                    <tr>
                        <th>
                            <span class="text-success">SELLING</span>
                        </th>
                        <th>
                            <span class="text-danger">BUYING</span>
                        </th>
                    </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
</body>

</html>